/// A Dart wrapper for the Discord API
library circumstellar;

import 'package:circumstellar/src/entity_manager.dart';
// For internal files
import 'package:w_transport/w_transport.dart' as transport;
import 'dart:io';
import 'dart:async';
import 'dart:convert';
import 'package:circumstellar/src/ws/heartbeat.dart';
import 'package:circumstellar/src/connect_status.dart';
import 'package:circumstellar/src/models/ws_payload.dart';

// REST
part 'src/rest/discord_rest.dart';
part 'src/rest/request_options.dart';
part 'src/rest/rest_response.dart';

// WebSocket
part 'src/ws/discord_ws.dart';

// Client
part 'src/discord_client.dart';
part 'src/models/auth_set.dart';

// Constants
part 'src/discord_constants.dart';
part 'src/circumstellar_constants.dart';

// Event dispatcher
part 'src/models/event_dispatcher.dart';

// Models
part 'src/models/entity.dart';
part 'src/models/discord_objects/message.dart';
part 'src/models/discord_objects/user.dart';
part 'src/models/discord_objects/channels/base_channel.dart';
part 'src/models/discord_objects/channels/guild_text_channel.dart';
part 'src/models/discord_objects/guilds/guild.dart';

// Exceptions
part 'src/errors/resume_exception.dart';
part 'src/errors/cache_exception.dart';

// Utils
part 'src/models/images.dart';
part 'src/logging/logger.dart';
