part of circumstellar;

class GuildTextChannel extends BaseChannel {
  GuildTextChannel(DiscordClient client) : super(client);

  Future updateModel(Map<String, dynamic> json, DiscordClient client) async {
    this.id = json['id'];
    this.type = json['type'] ?? this.type;
    this.guildId = json['guild_id'] ?? this.guildId;
    this.topic = json['topic'] ?? this.topic;
    this.sortingPosition = json['position'] ?? this.sortingPosition;
    this.name = json['name'] ?? this.name;
    this.isNsfw = json['nsfw'] ?? this.isNsfw;
    this.lastMessageId = json['last_message_id'] ?? this.lastMessageId;
    this.parentCategoryId = json['parent_id'] ?? this.parentCategoryId;

    this.guild =
        (await client.entities.getEntity(json['guild_id'], 'Guild') as Guild) ??
            this.guild;
  }

  // GuildTextChannel properties

  /// The ID of the guild this channel belongs to.
  String guildId = "";

  /// The [Guild] this channel belongs to.
  Guild guild = null;

  /// The position of this guild in the channel list (sorting position)
  int sortingPosition = 1;

  // TODO: Permission overwrites

  /// The name of this channel.
  String name = '';

  /// The topic of this channel.
  String topic = '';

  /// If this channel is NSFW (Not Safe For Work)
  bool isNsfw = false;

  /// The message ID of the last message sent to this channel.
  String lastMessageId = ''; // TODO: Implement this as a Message entity

  /// The ID of the parent category
  String parentCategoryId = '';

  // TODO: Last Pin Timestamps

  Future<RestRequestResult> createMessage(String content,
          {Map<String, dynamic> embed, bool tts, RequestOptions options}) =>
      this.client.createMessage(this.id, content,
          embed: embed, tts: tts, options: options);
}
