part of circumstellar;

class Guild extends Entity {
  Guild(DiscordClient client) : super(client);

  // Guild properties

  /// The name of this guild.
  String name = "";

  /// The image hash of this guilds icon.
  String iconHash = "";

  /// Gets a URL to the Discord CDN for the icon of this guild.
  String getIconUrl(String format) =>
      CDNImageHelper.guildIconEndpoint(this.id, this.iconHash, format);

  /// The image hash of this guilds splash.
  String splashHash = "";

  /// Gets a URL to the Discord CDN for the splash of this guild.
  String getSplashUrl(String format) =>
      CDNImageHelper.guildSplashEndpoint(this.id, this.splashHash, format);

  /// Whether or not this user is the owner of this guild.
  bool isOwner = null;

  /// The owner of this guild.
  User owner = null;

  // TODO: Permissions

  /// The voice region ID for this guild.
  String region = "";

  // The AFK channel (if one exists)
  // TODO: Voice channels

  /// The AFK timeout for this server (in seconds)
  int afkTimeoutSeconds = 0;

  // TODO: AFK Channels

  /// The verification level required to chat in this guild. You can use [GuildVerificationLevelHelper] to assist you.
  int verificationLevel = 0;

  /// The MFA level of this guild. You can use [MFALevelHelper] to assist you.
  int mfaLevel = 0;

  /// The Explicit Content Filter level of this guild. You can use [ExplicitContentFilterHelper] to assist you.
  int explicitContentFilterLevel = 0;

  /// The default message notification level of this guild. You can use [DefaultMessageNotificationHelper] to assist you.
  int defaultMessageNotificationLevel = 0;

  /// The application ID of the guild's creator if it is bot-created.
  String applicationId = "";

  @override
  Future updateModel(Map<String, dynamic> json, DiscordClient client) async {
    this.id = json['id'] ?? this.id;
    this.name = json['name'] ?? this.name;
    this.iconHash = json['icon'] ?? this.iconHash;
    this.splashHash = json['splash'] ?? this.splashHash;
    this.isOwner = json['owner'] ?? this.isOwner;
    this.region = json['region'] ?? this.region;
    this.afkTimeoutSeconds = json['afk_timeout'] ?? this.afkTimeoutSeconds;
    this.verificationLevel =
        json['verification_level'] ?? this.verificationLevel;
    this.mfaLevel = json['mfa_level'] ?? this.mfaLevel;
    this.explicitContentFilterLevel =
        json['explicit_content_filter'] ?? this.explicitContentFilterLevel;
    this.defaultMessageNotificationLevel =
        json['default_message_notifications'] ??
            this.defaultMessageNotificationLevel;

    this.owner =
        ((await client.entities.getEntity(json['owner_id'], 'User')) as User) ??
            this.owner;
  }
}
