part of circumstellar;

class Message extends Entity {
  /// The channel that this message was sent in.
  GuildTextChannel channel = null;

  /// The author of this message.
  User author = null;

  /// Content of this message.
  String content = '';

  /// Whether this message was a TTS message (Text-To-Speech)
  bool isTTS = false;

  /// Whether this message mentioned everyone
  bool mentionsEveryone = false;

  /// List of users who have been mentioned
  List<User> mentions = [];

  /// Whether this message has been pinned
  bool pinned = false;

  /// The type of message. You can use [MessageTypeHelper] to help with this.
  int type = 0;

  Future updateModel(Map<String, dynamic> json, DiscordClient client) async {
    this.id = json['id'] ?? this.id;
    this.content = json['content'] ?? this.content;
    this.author = await client.entities
        .getEntity((json['author']['id'] ?? this.author.id), 'User');
    this.isTTS = json['tts'] ?? this.isTTS;
    this.mentionsEveryone = json['mention_everyone'] ?? this.mentionsEveryone;
    this.channel =
        await client.entities.getEntity(json['channel_id'], 'GuildTextChannel');

    if (json['mentions'] != null) {
      var mentions0 = new List.from(json['mentions']);
      mentions0.forEach((mention1) async {
        this
            .mentions
            .add(await client.entities.getEntity(mention1['id'], 'User'));
      });
    }
    this.type = json['type'] ?? this.type;
  }

  Message(DiscordClient client) : super(client);
}
