part of circumstellar;

class User extends Entity {
  /// The user's username, not unique across Discord
  String username = '';

  /// The user's discriminator, their 4-digit Discord tag
  String discriminator = '';

  /// The integer value of the user's discriminator
  int discriminatorValue = 0;

  /// Whether the user belongs to an OAuth2 application
  bool isBot = false;

  /// Whether the user has Two-Factor Authentication (2FA) enabled
  bool twoFactorEnabled = false;

  User(DiscordClient client) : super(client);

  Future updateModel(Map<String, dynamic> json, DiscordClient client) async {
    this.id = json['id'] ?? this.id;
    this.username = json['username'] ?? this.username;
    this.discriminator = json['discriminator'] ?? this.discriminator;
    this.discriminatorValue = int.parse(this.discriminator);
    this.isBot = json['bot'] ?? this.isBot;
    this.twoFactorEnabled = json['mfa_enabled'] ?? this.twoFactorEnabled;
  }
}
